/* ***** BEGIN LICENSE BLOCK *****
 *
 *    Open-Xchange Calendar Provider
 *
 *    All intellectual property rights in the Software are protected by
 *    international copyright laws.
 *
 *    Any modifications to this package must retain all copyright notices
 *    of the original copyright holder(s) for the original code used.
 *
 *    After any such modifications, the original code will still remain
 *    copyrighted by the copyright holder(s) or original author(s).
 *
 *     Copyright (C) 2008 - 2009 Sebastian Kauss | fusionworkx
 *     mail:	                 sebastian.kauss@fusionworkx.com
 *
 *     This program is free software; you can redistribute it and/or modify it
 *     under the terms of the GNU General Public License as published by the Free
 *     Software Foundation; either version 2 of the License, or (at your option)
 *     any later version.
 *
 *     This program is distributed in the hope that it will be useful, but
 *     WITHOUT ANY WARRANTY; without even the implied warranty of MERCHANTABILITY
 *     or FITNESS FOR A PARTICULAR PURPOSE. See the GNU General Public License
 *     for more details.
 *
 *     You should have received a copy of the GNU General Public License along
 *     with this program; if not, write to the Free Software Foundation, Inc., 59
 *     Temple Place, Suite 330, Boston, MA 02111-1307 USA
 *
 */

var iStatusBarHandler = Components.interfaces.IStatusBarHandler;
var nsISupports = Components.interfaces.nsISupports;

function StatusBarHandler() {
    // If you only need to access your component from Javascript, uncomment the following line:
    this.wrappedJSObject = this;
}

// class definition
StatusBarHandler.prototype = {

    QueryInterface: function(aIID) {
        if (!aIID.equals(iStatusBarHandler) && !aIID.equals(nsISupports)) {
            throw Components.results.NS_ERROR_NO_INTERFACE;
        }
        return this;
    },

    setMainDocument: function(mainDocument) {
        this.mainDocument = mainDocument;
    },

    updateStatusBar: function(text, style) {
    	//FIXME disabled THREADING (see comment in SyncManager.js)
//        if (isTB3) {
//            var statusBarWorkerThread = new StatusBarWorkerThread(this.mainDocument, text, style);
//
//            var threadManager = Components.classes["@mozilla.org/thread-manager;1"].getService();
//            var mainThread = threadManager.mainThread;
//            mainThread.dispatch(statusBarWorkerThread, mainThread.DISPATCH_NORMAL);
//        } else {
            setStatusBarLabel(this.mainDocument, text, style);
//        }
    }
};

function StatusBarWorkerThread(mainDocument, text, style) {
    this.mainDocument = mainDocument;
    this.text = text;
    this.style = style;
}

StatusBarWorkerThread.prototype = {
    QueryInterface: function(iid) {
        if (iid.equals(Components.interfaces.nsIRunnable) ||
            iid.equals(Components.interfaces.nsISupports))
            return this;
        throw Components.results.NS_ERROR_NO_INTERFACE;
    },

    run: function() {
        setStatusBarLabel(this.mainDocument, this.text, this.style);
    }
};

function setStatusBarLabel(mainDocument, text, style) {
    var elementStatusLabel = mainDocument.getElementById("oxcalendarStatusLabel");

    text = " " + text;

    if (style) {
        elementStatusLabel.setAttribute("style", style);
    } else {
        elementStatusLabel.setAttribute("style", "font-weight:bold;color:#000000");
    }
    elementStatusLabel.label = text;
}
