/* ***** BEGIN LICENSE BLOCK *****
 *
 *    Open-Xchange Calendar Provider
 *
 *    All intellectual property rights in the Software are protected by
 *    international copyright laws.
 *
 *    Any modifications to this package must retain all copyright notices 
 *    of the original copyright holder(s) for the original code used.
 *    
 *    After any such modifications, the original code will still remain
 *    copyrighted by the copyright holder(s) or original author(s).
 *
 *     Copyright (C) 2008 - 2009 Sebastian Kauss | fusionworkx
 *     mail:	                 sebastian.kauss@fusionworkx.com
 *
 *     This program is free software; you can redistribute it and/or modify it
 *     under the terms of the GNU General Public License as published by the Free
 *     Software Foundation; either version 2 of the License, or (at your option)
 *     any later version.
 * 
 *     This program is distributed in the hope that it will be useful, but
 *     WITHOUT ANY WARRANTY; without even the implied warranty of MERCHANTABILITY
 *     or FITNESS FOR A PARTICULAR PURPOSE. See the GNU General Public License
 *     for more details.
 * 
 *     You should have received a copy of the GNU General Public License along
 *     with this program; if not, write to the Free Software Foundation, Inc., 59
 *     Temple Place, Suite 330, Boston, MA 02111-1307 USA
 * 
 */

var globalMailItem;

var globalCalendar;
var globalMailItem;

FW_LOG("tb3 imip-bar overlay");

var oldLtnItipOptions = window.ltnItipOptions;
window.ltnItipOptions = oxcalendarLtnItipOptions;

function itemFoundCallback(item, calendar) {
    FW_LOG("item found in local store, update button actions and imip-bar label");

    globalMailItem = item;
    globalCalendar = calendar;

    //let imipBar = document.getElementById("imip-bar");
    //imipBar.setAttribute("label", ltnGetString("lightning", "imipAddedItemToCal"));

    var button1 = document.getElementById("imip-button1");
    var button2 = document.getElementById("imip-button2");
    var button3 = document.getElementById("imip-button3");

    var i18nStatusLabelStr = getI18nString('oxcalendar-provider.confirmation.status');

    if (item.status == 'CONFIRMED') {
        i18nStatusStr = getI18nString('oxcalendar-provider.confirmation.confirmed');
    } else if (item.status == 'CANCELLED') {
        i18nStatusStr = getI18nString('oxcalendar-provider.confirmation.cancelled');
    } else {
        i18nStatusStr = getI18nString('oxcalendar-provider.confirmation.unconfirmed');
    }

    var imipBar = document.getElementById("imip-bar");
    imipBar.setAttribute("label", ltnGetString("lightning", "imipBarRequestText") + " " + i18nStatusLabelStr + ": ( " + i18nStatusStr + " )");

    button1.setAttribute("oncommand", "setOXAttendeeStatus4TB3('ACCEPTED');");
    button1.setAttribute("label", ltnGetString("lightning", "imipAcceptInvitation.label"));
    button2.setAttribute("oncommand", "setOXAttendeeStatus4TB3('DECLINED');");
    button2.setAttribute("label", ltnGetString("lightning", "imipDeclineInvitation.label"));

    showElement(button1);
    showElement(button2);
    hideElement(button3);
}

function noItemCallback(first, item) {
    if (first) {
        FW_LOG("item not found in local storage, try to refresh the local storage");
        
        var iSyncManager = Components.classes['@fusionworkx.com/common/syncmanager;1'].getService().wrappedJSObject;
        iSyncManager.init( refreshLocalStorageTB3Ready, ImipSyncOptions);
    } else {
        FW_LOG("item still not found in local storage, let the user choose what to do next");
    }
}

function refreshLocalStorageTB3Ready() {
    searchItemInLocalStorage(false, globalMailItem, itemFoundCallback, noItemCallback);
}

function oxcalendarLtnItipOptions(itipItem, rc, actionFunc) {
    FW_LOG("oxcalendarLtnImipOnLoad: itipItem=" + itipItem.toSource());

    // call orginal ltnImipOnLoad method first and than do the Open-Xchange checks

    var itemList = itipItem.getItemList({});
    if (itemList.length == 0) {
        FW_LOG("itip item was empty, ignore attachment and call original ltnImip method");


        window.oldLtnItipOptions(itipItem, rc, actionFunc);
        return;
    }

    globalMailItem = itemList[0];

    // add attribute to identify this item as an mail notification item
    globalMailItem.setProperty('FX_ITIP_ITEM', '1');
    
    itemList[0] = globalMailItem;

    window.oldLtnItipOptions(itipItem, rc, actionFunc);

    FW_LOG("overidden ltnImipOnLoad event called");

    searchItemInLocalStorage(true, globalMailItem, itemFoundCallback, noItemCallback);
}

function setOXAttendeeStatus4TB3(status) {
    setOXAttendeeStatus(status, globalMailItem, globalCalendar);
}

