/* ***** BEGIN LICENSE BLOCK *****
 *
 *    Open-Xchange Calendar Provider
 *
 *    All intellectual property rights in the Software are protected by
 *    international copyright laws.
 *
 *    Any modifications to this package must retain all copyright notices 
 *    of the original copyright holder(s) for the original code used.
 *    
 *    After any such modifications, the original code will still remain
 *    copyrighted by the copyright holder(s) or original author(s).
 *
 *     Copyright (C) 2008 - 2009 Sebastian Kauss | fusionworkx
 *     mail:	                 sebastian.kauss@fusionworkx.com
 *
 *     This program is free software; you can redistribute it and/or modify it
 *     under the terms of the GNU General Public License as published by the Free
 *     Software Foundation; either version 2 of the License, or (at your option)
 *     any later version.
 * 
 *     This program is distributed in the hope that it will be useful, but
 *     WITHOUT ANY WARRANTY; without even the implied warranty of MERCHANTABILITY
 *     or FITNESS FOR A PARTICULAR PURPOSE. See the GNU General Public License
 *     for more details.
 * 
 *     You should have received a copy of the GNU General Public License along
 *     with this program; if not, write to the Free Software Foundation, Inc., 59
 *     Temple Place, Suite 330, Boston, MA 02111-1307 USA
 * 
 */

Components.utils.import("resource://calendar/modules/calProviderUtils.jsm");

function calOXCalendar() {
	this.initProviderBase();

	initOXCalendar(this);

	calendarItipTransport.mail = this.getProperty("organizerId");
}

calOXCalendar.prototype = {
    __proto__: cal.ProviderBase.prototype,


    observer_init: function () {
        FW_LOG("OBSERVER_INIT");
        this.savePrefObserver = new commonCalendarObserver("save_pref", this);
    },

    QueryInterface: function fx_QueryInterface(aIID) {
        return doQueryInterface(this,
        calOXCalendar.prototype,
        aIID,
        null,
        classInfo["calOXCalendar"]);
    },

    get type() {
        return "oxcalendar";
    },

    get uri() {
        return this.mUri;
    },

    set uri(aUri) {
        this.mUri = aUri;
        return this.mUri;
    },

    get sendItipInvitations() {
        return false;
    },

    get canRefresh() {
		return true;
    },
	
    getProperty: function(aName) {
		switch (aName) {
			// Capabilities
			case "capabilities.timezones.floating.supported":
			case "capabilities.attachments.supported":
			case "capabilities.priority.supported":
			case "capabilities.tasks.supported":
			case "capabilities.alarms.oninvitations.supported":
				return false;
			case "capabilities.privacy.values":
				return ["PUBLIC", "PRIVATE"];
			case "itip.transport":
				return calendarItipTransport;
		}

		return this.__proto__.__proto__.getProperty.apply(this, arguments);
    },

    adoptItem: function (aItem, aListener) {
		adoptCalendarItem(this, aItem, aListener);
    },

    addItem: function (aItem, aListener) {
        this.adoptItem( aItem.clone(), aListener );
    },

    modifyItem: function (aNewItem, aOldItem, aListener) {
		modifyCalendarItem(this, aNewItem, aOldItem, aListener);
    },

    deleteItem: function (aItem, aListener) {
		deleteCalendarItem(this, aItem, aListener);
    },

    getItem: function (aId, aListener) {
		getCalendarItem(this, aId, aListener);
    },

    getItems: function (aItemFilter, aCount, aRangeStart, aRangeEnd, aListener) {
	   getCalendarItems(this, aItemFilter, aCount, aRangeStart, aRangeEnd, aListener);
    },

    refresh: function() {
		calendarRefresh(this);

		this.observers.notify("onLoad", [ this ]);
    }
};
