/* ***** BEGIN LICENSE BLOCK *****
 *
 *    Open-Xchange Calendar Provider
 *
 *    All intellectual property rights in the Software are protected by
 *    international copyright laws.
 *
 *    Any modifications to this package must retain all copyright notices 
 *    of the original copyright holder(s) for the original code used.
 *    
 *    After any such modifications, the original code will still remain
 *    copyrighted by the copyright holder(s) or original author(s).
 *
 *     Copyright (C) 2008 - 2009 Sebastian Kauss | fusionworkx
 *     mail:	                 sebastian.kauss@fusionworkx.com
 *
 *     This program is free software; you can redistribute it and/or modify it
 *     under the terms of the GNU General Public License as published by the Free
 *     Software Foundation; either version 2 of the License, or (at your option)
 *     any later version.
 * 
 *     This program is distributed in the hope that it will be useful, but
 *     WITHOUT ANY WARRANTY; without even the implied warranty of MERCHANTABILITY
 *     or FITNESS FOR A PARTICULAR PURPOSE. See the GNU General Public License
 *     for more details.
 * 
 *     You should have received a copy of the GNU General Public License along
 *     with this program; if not, write to the Free Software Foundation, Inc., 59
 *     Temple Place, Suite 330, Boston, MA 02111-1307 USA
 * 
 */

function calRemoteHandler() {
    this.remoteHandler = { };
}

calRemoteHandler.prototype = {

    registerHandler: function (handlerName, handlerObj) {
        this.remoteHandler[handlerName] = handlerObj;
    },

    setHandler: function (handlerName) {
        this.defaultHandlerName = handlerName;
    },

    getHandler: function () {
        return this.remoteHandler[this.defaultHandlerName];
    },

    validateSession: function (host, username, password, callback, params, async) {
        this.remoteHandler[this.defaultHandlerName].validateSession(host, username, password, callback, params, async);
    },

    setSession: function(session, cookie) {
        this.remoteHandler[this.defaultHandlerName].setSession(session, cookie);
    },

    logout: function (host, parameterObj) {
        this.remoteHandler[this.defaultHandlerName].logout(host, parameterObj);
    },

    insertAppointment: function (host, appointmentData) {
        return this.remoteHandler[this.defaultHandlerName].insertAppointment(host, appointmentData);
    },

    updateAppointment: function (host, appointmentData) {
        return this.remoteHandler[this.defaultHandlerName].updateAppointment(host, appointmentData);
    },

    deleteAppointment: function (host, appointmentData) {
        return this.remoteHandler[this.defaultHandlerName].deleteAppointment(host, appointmentData);
    },

    readFolders: function (host, callback) {
        return this.remoteHandler[this.defaultHandlerName].readFolders(host, callback);
    },

    readAppointments: function (host, callback, async) {
        return this.remoteHandler[this.defaultHandlerName].readAppointments(host, callback, async);
    },

    readParticipantsMapping: function (host, parameterObj) {
        return this.remoteHandler[this.defaultHandlerName].readParticipantsMapping(host, parameterObj);
    },

    setRemoteFolderId: function (folder) {
        this.remoteHandler[this.defaultHandlerName].calendarFolder = folder;
    },

    setCalendar: function(calendar) {
        this.remoteHandler[this.defaultHandlerName].calendar = calendar;
    }
}